import React, { useCallback } from "react";
import { get, set } from "dot-prop-immutable";
import { useUi } from "@webiny/app/hooks/useUi";
import { IconButton } from "@webiny/ui/Button";
import { ReactComponent as MenuIcon } from "~/assets/icons/baseline-menu-24px.svg";

const Hamburger: React.FC = () => {
    const ui = useUi();

    const toggleMenu = useCallback(() => {
        ui.setState(ui => set(ui, "appsMenu.show", !(get(ui, "appsMenu.show") || false)));
    }, [ui]);

    return (
        <IconButton
            icon={<MenuIcon style={{ color: "white" }} />}
            onClick={toggleMenu}
            data-testid={"apps-menu"}
        />
    );
};

export default Hamburger;
