import getPsTags from "../../src/render/getPsTags";

describe("parse all <ps-tag .../>", () => {
    it("must detect all ps-tag tags in given HTML (unique must be true by default)", async () => {
        const results = getPsTags(TEST_STRING);

        expect(results).toEqual([
            {
                key: "pb-menu",
                value: "xyz-123"
            },
            {
                key: "pb-pages-list"
            }
        ]);
    });

    it("must detect all ps-tag tags in given HTML (unique set to false)", async () => {
        const results = getPsTags(TEST_STRING, false);

        expect(results).toEqual([
            {
                key: "pb-menu",
                value: "xyz-123"
            },
            {
                key: "pb-menu",
                value: "xyz-123"
            },
            {
                key: "pb-pages-list"
            }
        ]);
    });
});

const TEST_STRING = `"content" : "<ps-tag data-key=\"pb-menu\" data-value=\"xyz-123\"><!doctype html><html lang=\"en\"><head><meta charset=\"utf-8\"><meta name=\"viewport\" content=\"width=device-width,initial-scale=1,shrink-to-fit=no\"><meta name=\"theme-color\" content=\"#000000\"><link href=\"https://fonts.googleapis.com/css?family=IBM+Plex+Sans:400,500,700|Lato:400,700&display=swap\" rel=\"stylesheet\"><link href=\"/static/css/2.7abef457.chunk.css\" rel=\"stylesheet\"><link href=\"/static/css/main.2b1feecf.chunk.css\" rel=\"stylesheet\"><meta data-react-helmet=\"true\" charSet=\"utf-8\"/><title data-react-helmet=\"true\">404 | MySite</title></head><body><noscript>You need to enable JavaScript to run this app.</noscript>\n        <div id=\"root\"><div class=\"webiny-pb-page\"><ps-tag data-key=\"pb-menu\" data-value=\"xyz-123\"><div class=\"webiny-pb-section-header\"><div class=\"webiny-pb-section-header__wrapper hide-on-mobile\"><div class=\"webiny-pb-section-header__logo\"><a href=\"/\"> <span class=\"webiny-pb-section-header__site-name\">MySite</span></a></div><nav class=\"webiny-pb-section-header__navigation\"><ul><li><a href=\"/welcome-to-webiny\">Home</a></li></ul></nav></div><div class=\"webiny-pb-section-header__wrapper hide-on-desktop-and-tablet\"><div class=\"webiny-pb-section-header__logo\"><a href=\"/\"> <span class=\"webiny-pb-section-header__site-name\">MySite</span></a></div><nav class=\"webiny-pb-section-header__navigation\"><ul><li><a href=\"/welcome-to-webiny\">Home</a></li></ul><div class=\"webiny-pb-section-header__mobile-site-name\"><a href=\"/\">MySite</a></div></nav><div class=\"webiny-pb-section-header__mobile-icon\"><div style=\"width:18px;height:15px;position:relative;transform:rotate(0deg)\"><span style=\"display:block;height:1px;width:100%;background:black;transition-timing-function:ease;transition-duration:0.5s;border-radius:0px;transform-origin:center;position:absolute;transform:translate3d(0,0,0) rotate(0);margin-top:-0.5px\"></span><span style=\"display:block;height:1px;width:100%;background:black;transition-timing-function:ease-out;transition-duration:0.125s;border-radius:0px;transform-origin:center;position:absolute;opacity:1;top:7.5px;margin-top:-0.5px\"></span><span style=\"display:block;height:1px;width:100%;background:black;transition-timing-function:ease;transition-duration:0.5s;border-radius:0px;transform-origin:center;position:absolute;transform:translate3d(0,15px,0) rotate(0);margin-top:-0.5px\"></span></div></div><div class=\"webiny-pb-section-header__mobile-overlay\"></div></div></div><div class=\"webiny-pb-section-header-spacer\"></div></ps-tag><div class=\"webiny-pb-page-document\"><div style=\"width:100%;display:flex;justify-content:center\" class=\"webiny-pb-layout-block-container css-1nliqx-Block\"><div style=\"width:1000px\" class=\"webiny-pb-layout-block webiny-pb-base-page-element-style\"><div class=\"webiny-pb-base-page-element-style webiny-pb-layout-row\" style=\"--desktop-padding-top:0px;--mobile-padding-top:0px;--desktop-padding-right:0px;--mobile-padding-right:0px;--desktop-padding-bottom:0px;--mobile-padding-bottom:0px;--desktop-padding-left:0px;--mobile-padding-left:0px;--desktop-margin-top:0px;--mobile-margin-top:0px;--desktop-margin-right:0px;--mobile-margin-right:0px;--desktop-margin-bottom:0px;--mobile-margin-bottom:0px;--desktop-margin-left:0px;--mobile-margin-left:0px\"><div class=\"webiny-pb-base-page-element-style webiny-pb-layout-column\" style=\"width:100%;--desktop-padding-top:0px;--mobile-padding-top:0px;--desktop-padding-right:0px;--mobile-padding-right:0px;--desktop-padding-bottom:0px;--mobile-padding-bottom:0px;--desktop-padding-left:0px;--mobile-padding-left:0px;--desktop-margin-top:0px;--mobile-margin-top:0px;--desktop-margin-right:0px;--mobile-margin-right:0px;--desktop-margin-bottom:0px;--mobile-margin-bottom:0px;--desktop-margin-left:0px;--mobile-margin-left:0px\"><div class=\"webiny-pb-base-page-element-style webiny-pb-page-element-text\" style=\"--desktop-margin-top:0px;--mobile-margin-top:0px;--desktop-margin-right:0px;--mobile-margin-right:0px;--desktop-margin-bottom:0px;--mobile-margin-bottom:15px;--desktop-margin-left:0px;--mobile-margin-left:0px\"><div data-slate-editor=\"true\" data-key=\"26\" autoCorrect=\"off\" spellcheck=\"false\" style=\"outline:none;white-space:pre-wrap;word-wrap:break-word\" data-gramm=\"false\"><h2 data-key=\"27\" class=\"webiny-pb-typography-h2\" style=\"text-align:center\"><span data-key=\"28\"><span data-offset-key=\"28:0\">Page not found</span></span></h2></div></div><div class=\"webiny-pb-base-page-element-style webiny-pb-page-element-image\" style=\"text-align:center;--desktop-padding-top:0px;--mobile-padding-top:0px;--desktop-padding-right:0px;--mobile-padding-right:0px;--desktop-padding-bottom:0px;--mobile-padding-bottom:0px;--desktop-padding-left:0px;--mobile-padding-left:0px;--desktop-margin-top:25px;--mobile-margin-top:15px;--desktop-margin-right:25px;--mobile-margin-right:15px;--desktop-margin-bottom:25px;--mobile-margin-bottom:15px;--desktop-margin-left:25px;--mobile-margin-left:15px\"><img style=\"width:250px;height:100%\" src=\"https://d2o1ehyyouhl2.cloudfront.net/files/7k4aa0gls-undraw_page_not_found_su7k_1b8ujs7v2x7p.svg\" srcSet=\"https://d2o1ehyyouhl2.cloudfront.net/files/7k4aa0gls-undraw_page_not_found_su7k_1b8ujs7v2x7p.svg 100w, https://d2o1ehyyouhl2.cloudfront.net/files/7k4aa0gls-undraw_page_not_found_su7k_1b8ujs7v2x7p.svg 300w\"/></div><div class=\"webiny-pb-base-page-element-style webiny-pb-page-element-text\" style=\"--desktop-padding-top:0px;--mobile-padding-top:0px;--desktop-padding-right:300px;--mobile-padding-right:0px;--desktop-padding-bottom:0px;--mobile-padding-bottom:0px;--desktop-padding-left:300px;--mobile-padding-left:0px;--desktop-margin-top:25px;--mobile-margin-top:0px;--desktop-margin-right:0px;--mobile-margin-right:0px;--desktop-margin-bottom:50px;--mobile-margin-bottom:0px;--desktop-margin-left:0px;--mobile-margin-left:0px\"><div data-slate-editor=\"true\" data-key=\"30\" autoCorrect=\"off\" spellcheck=\"false\" style=\"outline:none;white-space:pre-wrap;word-wrap:break-word\" data-gramm=\"false\"><p data-key=\"31\" class=\"webiny-pb-typography-body\" style=\"text-align:center\"><span data-key=\"32\"><span data-offset-key=\"32:0\">Seems the page that you are looking for doesn&#x27;t exists, or is no longer available. </span></span></p><p data-key=\"33\" class=\"webiny-pb-typography-body\" style=\"text-align:center\"><span data-key=\"34\"><span data-offset-key=\"34:0\"><span data-slate-zero-width=\"z\">﻿</span></span></span><a data-key=\"35\" target=\"_self\" href=\"/\"><span data-key=\"36\"><span data-offset-key=\"36:0\">Click here to go back to the homepage</span></span></a><span data-key=\"37\"><span data-offset-key=\"37:0\"><span data-slate-zero-width=\"z\">﻿</span></span></span></p></div></div></div></div></div></div></div><div class=\"webiny-pb-section-footer\"><div class=\"webiny-pb-section-footer__wrapper\"><div class=\"webiny-pb-section-footer__logo\"><a href=\"/\"></a><div class=\"webiny-pb-section-footer__copy webiny-pb-typography-description\">MySite © 2019</div></div></div></div></div></div>\n        <script>\n            window.__APOLLO_STATE__={\"5df9300fc4df0e0008b68c8c\":{\"id\":\"5df9300fc4df0e0008b68c8c\",\"code\":\"en-US\",\"__typename\":\"I18NLocale\",\"default\":true},\"$ROOT_QUERY.i18n.getI18NInformation\":{\"currentLocale\":{\"type\":\"id\",\"generated\":false,\"id\":\"5df9300fc4df0e0008b68c8c\",\"typename\":\"I18NLocale\"},\"locales\":[{\"type\":\"id\",\"generated\":false,\"id\":\"5df9300fc4df0e0008b68c8c\",\"typename\":\"I18NLocale\"}],\"__typename\":\"I18NInformationResponse\"},\"$ROOT_QUERY.i18n\":{\"getI18NInformation\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.i18n.getI18NInformation\",\"typename\":\"I18NInformationResponse\"},\"__typename\":\"I18NQuery\"},\"ROOT_QUERY\":{\"i18n\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.i18n\",\"typename\":\"I18NQuery\"},\"pageBuilder\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.pageBuilder\",\"typename\":\"PbQuery\"},\"cookiePolicy\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.cookiePolicy\",\"typename\":\"CookiePolicyQuery\"},\"googleTagManager\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.googleTagManager\",\"typename\":\"GtmQuery\"}},\"$ROOT_QUERY.pageBuilder.getPublishedPage({\\\"url\\\":\\\"/sada\\\"})\":{\"data\":null,\"error\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.pageBuilder.getPublishedPage({\\\"url\\\":\\\"/sada\\\"}).error\",\"typename\":\"PbError\"},\"__typename\":\"PbPageResponse\"},\"$ROOT_QUERY.pageBuilder.getPublishedPage({\\\"url\\\":\\\"/sada\\\"}).error\":{\"code\":\"NOT_FOUND\",\"message\":\"The requested page was not found.\",\"__typename\":\"PbError\"},\"$ROOT_QUERY.pageBuilder\":{\"getPublishedPage({\\\"url\\\":\\\"/sada\\\"})\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.pageBuilder.getPublishedPage({\\\"url\\\":\\\"/sada\\\"})\",\"typename\":\"PbPageResponse\"},\"getErrorPage\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.pageBuilder.getErrorPage\",\"typename\":\"PbPageResponse\"},\"getNotFoundPage\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.pageBuilder.getNotFoundPage\",\"typename\":\"PbPageResponse\"},\"getSettings\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.pageBuilder.getSettings\",\"typename\":\"PbSettingsResponse\"},\"__typename\":\"PbQuery\",\"getMenuBySlug({\\\"slug\\\":\\\"main-menu\\\"})\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.pageBuilder.getMenuBySlug({\\\"slug\\\":\\\"main-menu\\\"})\",\"typename\":\"PbMenuResponse\"}},\"5c6862e4a0b03cef2ef1dec1\":{\"id\":\"5c6862e4a0b03cef2ef1dec1\",\"title\":\"Error Page\",\"url\":\"/error\",\"version\":1,\"publishedOn\":\"2019-12-17T19:44:50.422Z\",\"snippet\":null,\"content\":{\"type\":\"json\",\"json\":{\"id\":\"P3NNeXWAk\",\"data\":{},\"settings\":{},\"elements\":[{\"id\":\"jjmIfB57p\",\"data\":{\"settings\":{\"padding\":{\"advanced\":true,\"desktop\":{\"top\":100,\"bottom\":100},\"mobile\":{\"top\":15,\"bottom\":15,\"right\":15,\"left\":15}},\"width\":{\"value\":\"1000px\"}}},\"elements\":[{\"data\":{\"settings\":{\"margin\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}},\"padding\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}}}},\"elements\":[{\"data\":{\"width\":100,\"settings\":{\"margin\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}},\"padding\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}}}},\"elements\":[{\"data\":{\"text\":{\"object\":\"value\",\"document\":{\"object\":\"document\",\"data\":{},\"nodes\":[{\"object\":\"block\",\"type\":\"h2\",\"data\":{\"align\":\"center\"},\"nodes\":[{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"Oops ... there has been an error\",\"marks\":[]}]}]}]}},\"settings\":{\"margin\":{\"advanced\":true,\"mobile\":{\"bottom\":15}}}},\"elements\":[],\"type\":\"text\",\"id\":\"nEXNvcLJO5\",\"path\":\"0.0.0.0.0\"},{\"id\":\"EoAI5_Y9t\",\"data\":{\"settings\":{\"horizontalAlign\":\"center\",\"margin\":{\"desktop\":{\"all\":25,\"top\":25,\"right\":25,\"bottom\":25,\"left\":25},\"mobile\":{\"top\":15,\"left\":15,\"right\":15,\"bottom\":15,\"all\":15},\"advanced\":false},\"padding\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}}},\"image\":{\"width\":\"250\",\"responsive\":true,\"height\":\"\",\"title\":\"\",\"file\":{\"id\":\"5db3410646e6da8d61cc1392\",\"src\":\"https://d2o1ehyyouhl2.cloudfront.net/files/7k4aa0glt-undraw_warning_cyit_1b8ujs7vdjzp.svg\"}}},\"elements\":[],\"path\":\"0.0.0.0.1\",\"type\":\"image\"},{\"data\":{\"text\":{\"object\":\"value\",\"document\":{\"object\":\"document\",\"data\":{},\"nodes\":[{\"object\":\"block\",\"type\":\"paragraph\",\"data\":{\"align\":\"center\"},\"nodes\":[{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"An error has happened somewhere.\",\"marks\":[]}]}]},{\"object\":\"block\",\"type\":\"paragraph\",\"data\":{\"align\":\"center\"},\"nodes\":[{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"\",\"marks\":[]}]},{\"object\":\"inline\",\"type\":\"link\",\"data\":{\"href\":\"/\"},\"nodes\":[{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"Click here to go back to the homepage\",\"marks\":[]}]}]},{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"\",\"marks\":[]}]}]}]}},\"settings\":{\"padding\":{\"desktop\":{\"all\":200,\"right\":300,\"left\":300,\"bottom\":0,\"top\":0},\"advanced\":true},\"margin\":{\"advanced\":true,\"desktop\":{\"top\":25,\"bottom\":50}}}},\"elements\":[],\"type\":\"text\",\"id\":\"DK3FJSgHH-\",\"path\":\"0.0.0.0.2\"}],\"type\":\"column\",\"id\":\"h4Xd4xXx_2\",\"path\":\"0.0.0.0\"}],\"type\":\"row\",\"id\":\"gRhWPLjCEt\",\"path\":\"0.0.0\"}],\"path\":\"0.0\",\"type\":\"block\",\"source\":\"5c27a54ca0b03cc8d9e32fcf\"}],\"path\":\"0\",\"type\":\"document\"}},\"createdBy\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6862e4a0b03cef2ef1dec1.createdBy\",\"typename\":\"SecurityUser\"},\"settings\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6862e4a0b03cef2ef1dec1.settings\",\"typename\":\"PbPageSettings\"},\"category\":{\"type\":\"id\",\"generated\":false,\"id\":\"5c436a2b4527ee6f2b8bf3d7\",\"typename\":\"PbCategory\"},\"__typename\":\"PbPage\"},\"$5c6862e4a0b03cef2ef1dec1.createdBy\":{\"firstName\":\"Adrian\",\"lastName\":\"Smith\",\"__typename\":\"SecurityUser\"},\"$5c6862e4a0b03cef2ef1dec1.settings\":{\"_empty\":\"\",\"general\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6862e4a0b03cef2ef1dec1.settings.general\",\"typename\":\"PbGeneralPageSettings\"},\"seo\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6862e4a0b03cef2ef1dec1.settings.seo\",\"typename\":\"PbSeoSettings\"},\"social\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6862e4a0b03cef2ef1dec1.settings.social\",\"typename\":\"PbSocialSettings\"},\"__typename\":\"PbPageSettings\"},\"$5c6862e4a0b03cef2ef1dec1.settings.general\":{\"image\":null,\"tags\":{\"type\":\"json\",\"json\":[\"page\",\"error\"]},\"layout\":\"static\",\"__typename\":\"PbGeneralPageSettings\"},\"$5c6862e4a0b03cef2ef1dec1.settings.seo\":{\"title\":null,\"description\":null,\"meta\":[],\"__typename\":\"PbSeoSettings\"},\"$5c6862e4a0b03cef2ef1dec1.settings.social\":{\"image\":null,\"title\":null,\"description\":null,\"meta\":[],\"__typename\":\"PbSocialSettings\"},\"5c436a2b4527ee6f2b8bf3d7\":{\"id\":\"5c436a2b4527ee6f2b8bf3d7\",\"name\":\"Static\",\"__typename\":\"PbCategory\"},\"$ROOT_QUERY.pageBuilder.getErrorPage\":{\"data\":{\"type\":\"id\",\"generated\":false,\"id\":\"5c6862e4a0b03cef2ef1dec1\",\"typename\":\"PbPage\"},\"error\":null,\"__typename\":\"PbPageResponse\"},\"5c6860fda0b03cef2e544bd7\":{\"id\":\"5c6860fda0b03cef2e544bd7\",\"title\":\"404\",\"url\":\"/not-found\",\"version\":1,\"publishedOn\":\"2019-12-17T19:44:50.467Z\",\"snippet\":null,\"content\":{\"type\":\"json\",\"json\":{\"id\":\"ikN6TMxu7\",\"data\":{},\"settings\":{},\"elements\":[{\"id\":\"OqBcnPf6K\",\"data\":{\"settings\":{\"padding\":{\"advanced\":true,\"desktop\":{\"top\":100,\"bottom\":100},\"mobile\":{\"top\":15,\"bottom\":15,\"right\":15,\"left\":15}},\"width\":{\"value\":\"1000px\"}}},\"elements\":[{\"data\":{\"settings\":{\"margin\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}},\"padding\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}}}},\"elements\":[{\"data\":{\"width\":100,\"settings\":{\"margin\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}},\"padding\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}}}},\"elements\":[{\"data\":{\"text\":{\"object\":\"value\",\"document\":{\"object\":\"document\",\"data\":{},\"nodes\":[{\"object\":\"block\",\"type\":\"h2\",\"data\":{\"align\":\"center\"},\"nodes\":[{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"Page not found\",\"marks\":[]}]}]}]}},\"settings\":{\"margin\":{\"advanced\":true,\"mobile\":{\"bottom\":15}}}},\"elements\":[],\"type\":\"text\",\"id\":\"q0l8eb-1X1\",\"path\":\"0.0.0.0.0\"},{\"id\":\"cObTtI3R8\",\"data\":{\"settings\":{\"horizontalAlign\":\"center\",\"margin\":{\"desktop\":{\"all\":25,\"top\":25,\"right\":25,\"bottom\":25,\"left\":25},\"mobile\":{\"top\":15,\"left\":15,\"right\":15,\"bottom\":15,\"all\":15},\"advanced\":false},\"padding\":{\"desktop\":{\"all\":0},\"mobile\":{\"all\":0}}},\"image\":{\"width\":\"250\",\"file\":{\"id\":\"5db3410646e6da8d61cc1391\",\"src\":\"https://d2o1ehyyouhl2.cloudfront.net/files/7k4aa0gls-undraw_page_not_found_su7k_1b8ujs7v2x7p.svg\"}}},\"elements\":[],\"path\":\"0.0.0.0.1\",\"type\":\"image\"},{\"data\":{\"text\":{\"object\":\"value\",\"document\":{\"object\":\"document\",\"data\":{},\"nodes\":[{\"object\":\"block\",\"type\":\"paragraph\",\"data\":{\"align\":\"center\"},\"nodes\":[{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"Seems the page that you are looking for doesn't exists, or is no longer available. \",\"marks\":[]}]}]},{\"object\":\"block\",\"type\":\"paragraph\",\"data\":{\"align\":\"center\"},\"nodes\":[{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"\",\"marks\":[]}]},{\"object\":\"inline\",\"type\":\"link\",\"data\":{\"href\":\"/\"},\"nodes\":[{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"Click here to go back to the homepage\",\"marks\":[]}]}]},{\"object\":\"text\",\"leaves\":[{\"object\":\"leaf\",\"text\":\"\",\"marks\":[]}]}]}]}},\"settings\":{\"padding\":{\"desktop\":{\"all\":200,\"right\":300,\"left\":300,\"bottom\":0,\"top\":0},\"advanced\":true},\"margin\":{\"advanced\":true,\"desktop\":{\"top\":25,\"bottom\":50}}}},\"elements\":[],\"type\":\"text\",\"id\":\"ccmga_z8J3\",\"path\":\"0.0.0.0.2\"}],\"type\":\"column\",\"id\":\"INbopVNADD\",\"path\":\"0.0.0.0\"}],\"type\":\"row\",\"id\":\"V58gMh4NkG\",\"path\":\"0.0.0\"}],\"path\":\"0.0\",\"type\":\"block\",\"source\":\"5c27a54ca0b03cc8d9e32fcf\"}],\"path\":\"0\",\"type\":\"document\"}},\"createdBy\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6860fda0b03cef2e544bd7.createdBy\",\"typename\":\"SecurityUser\"},\"settings\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6860fda0b03cef2e544bd7.settings\",\"typename\":\"PbPageSettings\"},\"category\":{\"type\":\"id\",\"generated\":false,\"id\":\"5c436a2b4527ee6f2b8bf3d7\",\"typename\":\"PbCategory\"},\"__typename\":\"PbPage\"},\"$5c6860fda0b03cef2e544bd7.createdBy\":{\"firstName\":\"Adrian\",\"lastName\":\"Smith\",\"__typename\":\"SecurityUser\"},\"$5c6860fda0b03cef2e544bd7.settings\":{\"_empty\":\"\",\"general\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6860fda0b03cef2e544bd7.settings.general\",\"typename\":\"PbGeneralPageSettings\"},\"seo\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6860fda0b03cef2e544bd7.settings.seo\",\"typename\":\"PbSeoSettings\"},\"social\":{\"type\":\"id\",\"generated\":true,\"id\":\"$5c6860fda0b03cef2e544bd7.settings.social\",\"typename\":\"PbSocialSettings\"},\"__typename\":\"PbPageSettings\"},\"$5c6860fda0b03cef2e544bd7.settings.general\":{\"image\":null,\"tags\":{\"type\":\"json\",\"json\":[\"page\",\"404\",\"not-found\"]},\"layout\":\"static\",\"__typename\":\"PbGeneralPageSettings\"},\"$5c6860fda0b03cef2e544bd7.settings.seo\":{\"title\":null,\"description\":null,\"meta\":[],\"__typename\":\"PbSeoSettings\"},\"$5c6860fda0b03cef2e544bd7.settings.social\":{\"image\":null,\"title\":null,\"description\":null,\"meta\":[],\"__typename\":\"PbSocialSettings\"},\"$ROOT_QUERY.pageBuilder.getNotFoundPage\":{\"data\":{\"type\":\"id\",\"generated\":false,\"id\":\"5c6860fda0b03cef2e544bd7\",\"typename\":\"PbPage\"},\"error\":null,\"__typename\":\"PbPageResponse\"},\"$ROOT_QUERY.pageBuilder.getSettings.data\":{\"name\":\"MySite\",\"social\":null,\"__typename\":\"PbSettings\",\"favicon\":null,\"logo\":null},\"$ROOT_QUERY.pageBuilder.getSettings\":{\"data\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.pageBuilder.getSettings.data\",\"typename\":\"PbSettings\"},\"__typename\":\"PbSettingsResponse\"},\"$ROOT_QUERY.cookiePolicy.getSettings\":{\"data\":null,\"__typename\":\"CookiePolicySettingsResponse\"},\"$ROOT_QUERY.cookiePolicy\":{\"getSettings\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.cookiePolicy.getSettings\",\"typename\":\"CookiePolicySettingsResponse\"},\"__typename\":\"CookiePolicyQuery\"},\"$ROOT_QUERY.googleTagManager.getSettings\":{\"data\":null,\"__typename\":\"GtmSettingsResponse\"},\"$ROOT_QUERY.googleTagManager\":{\"getSettings\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.googleTagManager.getSettings\",\"typename\":\"GtmSettingsResponse\"},\"__typename\":\"GtmQuery\"},\"$ROOT_QUERY.pageBuilder.getMenuBySlug({\\\"slug\\\":\\\"main-menu\\\"}).data\":{\"slug\":null,\"title\":\"Main menu\",\"items\":{\"type\":\"json\",\"json\":[{\"title\":\"Home\",\"url\":\"/welcome-to-webiny\",\"id\":\"5c86c7564527eea07b295f9d\",\"type\":\"page\"}]},\"__typename\":\"PbMenu\"},\"$ROOT_QUERY.pageBuilder.getMenuBySlug({\\\"slug\\\":\\\"main-menu\\\"})\":{\"data\":{\"type\":\"id\",\"generated\":true,\"id\":\"$ROOT_QUERY.pageBuilder.getMenuBySlug({\\\"slug\\\":\\\"main-menu\\\"}).data\",\"typename\":\"PbMenu\"},\"__typename\":\"PbMenuResponse\"}}\n        </script>\n    <script src=\"/static/js/runtime-main.c0fd5858.js\"></script><script src=\"/static/js/2.41323b94.chunk.js\"></script><script src=\"/static/js/main.42690184.chunk.js\"></script></body><ps-tag data-key=\"pb-pages-list\"></ps-tag></html>",`;
